<?php
namespace Claromentis\Infocapture\Controller\Rest;

$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] ?: array()) + array("_f76b20cae22026c8464" . "c78243696de97" => base64_decode("aW5mb2NhcHR1cmUuc" . "mVzdC5ub19wcm9qZW" . "N0"), "_c05f8f22b90692278db7" . "0d3c304711e5" => base64_decode("aW5mb2NhcHR1cmU" . "ucmVzdC5ub19wZX" . "JtaXNzaW9uX3Byb" . "2plY3Q="), "_79bd87060993ff622ef212c1e8b6a7" . "9a" => base64_decode("Rm9yYm" . "lkZGVu"), "_a4a1018258adabb74e7b0" . "4836d8d7e3b" => base64_decode("Tm90IE" . "ZvdW5k"));
use Claromentis\Core\Http\JsonPrettyResponse;
use Claromentis\Core\Http\ResponseFactory;
use Claromentis\Core\Localization\Lmsg;
use Claromentis\Infocapture\Exception\NotFoundException;
use Claromentis\Infocapture\Exception\PermissionException;
use Claromentis\Infocapture\Filter\ProjectFilter;
use Claromentis\Infocapture\RestFormatter;
use Claromentis\Core\Security\SecurityContext;
use Claromentis\Infocapture\Api;
use Psr\Http\Message\ServerRequestInterface;
class ProjectController
{
    protected Api $api;
    protected Lmsg $lmsg;
    protected RestFormatter $formatter;
    protected ResponseFactory $response;
    public function __construct(Api $api, RestFormatter $formatter, ResponseFactory $response, Lmsg $lmsg)
    {
        $this->api = $api;
        $this->formatter = $formatter;
        $this->response = $response;
        $this->lmsg = $lmsg;
    }
    
    
    
    
    
    
    
    
    
    
    public function getProject(SecurityContext $context, int $projectId) : JsonPrettyResponse
    {
        try {
            $project = $this->api->getProject($context, $projectId);
        } catch (NotFoundException $_c35473364fa7a050299058f332ec29c1) {
            throw new \RestExNotFound(($this->lmsg)($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_f76b20cae22026c8464c7824369" . "6de97"]), $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_a4a1018258adabb7" . "4e7b04836d8d7e3b"], $_c35473364fa7a050299058f332ec29c1);
        } catch (PermissionException $_c35473364fa7a050299058f332ec29c1) {
            throw new \RestExForbidden(($this->lmsg)($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_c05f8f22b90692" . "278db70d3c30471" . "1e5"]), $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_79bd87060993ff622ef212c1e8b6a7" . "9a"], $_c35473364fa7a050299058f332ec29c1);
        }
        return $this->response->GetJsonPrettyResponse($this->formatter->FormatProject($project));
    }
    
    
    
    
    
    
    
    
    
    public function getProjects(SecurityContext $context, ServerRequestInterface $request) : JsonPrettyResponse
    {
        $_03e9164d0a343b742df4793268b80767 = new ProjectFilter();
        $_03e9164d0a343b742df4793268b80767->fill($request);
        $_68680c984182bf7876b2bb0ab77ebe01 = $this->api->getProjects($context, $_03e9164d0a343b742df4793268b80767);
        $_264e8772c4dd469c7acd9dc850e932fa = $this->formatter->FormatProjects($_68680c984182bf7876b2bb0ab77ebe01);
        $total = $this->api->getProjectsCount($_03e9164d0a343b742df4793268b80767);
        $response = $this->formatter->Paginate($request, $_264e8772c4dd469c7acd9dc850e932fa, $_03e9164d0a343b742df4793268b80767->toArray(), $total);
        return $this->response->GetJsonPrettyResponse($response);
    }
}